/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 16/11/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.ShiftKerja;
import com.portofolio.entity.vo.ShiftKerjaId;

import org.springframework.context.annotation.Lazy;

@Lazy
@Repository
public interface ShiftKerjaDao extends CrudRepository<ShiftKerja, ShiftKerjaId> {

    @Cacheable("ShiftKerjaDaofindOneBy")
    ShiftKerja findOneByIdKodeAndIdKdProfileAndKdDepartemen(Integer kode, Integer kdProfile, String KdDepartemen);
    

    @Query(QListAll)
    @Cacheable("ShiftKerjaDaoFindAllList")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, Pageable page, @Param("kdDepartemen") String kdDepartemen);
    
    @Query(QListAll + " and model.namaShift like %:namaShift% ")
    @Cacheable("ShiftKerjaDaoFindAllListPage")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaShift") String namaShift, Pageable page, @Param("kdDepartemen") String kdDepartemen);
    
    @Query(QListAll + " and model.id.kode like :kode")
    @Cacheable("ShiftKerjaDaoFindByKode")
    Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode, @Param("kdDepartemen") String kdDepartemen);
    
    
    
    String QListAll ="select new map(model.id.kdShift as kdShift,model.id.kdProfile as kdProfile "
            + ", model.namaShift as namaShift " 
            + ", model.reportDisplay as reportDisplay " 
            + ", model.jamMasuk as jamMasuk " 
            + ", model.jamPulang as jamPulang " 
            + ", model.qtyJamKerjaEfektif as qtyJamKerjaEfektif " 
            + ", model.jamBreakAwal as jamBreakAwal " 
            + ", model.jamBreakAkhir as jamBreakAkhir " 
            + ", model.qtyJamBreakEfektif as qtyJamBreakEfektif " 
            + ", model.factorRate as factorRate " 
            + ", model.operatorFactorRate as operatorFactorRate " 
            + ", model.kdKomponenIndex as kdKomponenIndex "
            + ", komponenIndex.namaKomponen as namaKomponenIndex " 
            + ", model.kodeExternal as kodeExternal " 
            + ", model.namaExternal as namaExternal " 
            + ", model.kdDepartemen as kdDepartemen " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec " 
            + ", departemen.namaDepartemen as namaDepartemen, model.version as version )" 
            + " from ShiftKerja model left join model.id id "
            + " left join model.departemen departemen "
            + " left join model.komponenIndex komponenIndex "
            + " left join model.profile profile where profile.kode =:kdProfile and model.kdDepartemen = :kdDepartemen "; 

}
